Vagrant.configure(2) do |config|
    etcHosts = ""
    domainName = "ais-wf3.local"

    # listes des Noeuds 
    NODES = [
        {:hostname => "DNS",  :ip => "192.168.56.10", :cpu => 2, :mem => 2048 , :box => "debian/stretch64", :type => "dns"},
        {:hostname => "PKI", :ip => "192.168.56.11", :cpu => 2, :mem => 2048 , :box => "debian/buster64", :type => "pki" },
        {:hostname => "WEB", :ip => "192.168.56.12", :cpu => 2, :mem => 2048 , :box => "debian/buster64", :type => "web" },
    ]

#    config.vm.box = "debian/stretch64"

    NODES.each do |node|
        etcHosts += "echo '" + node[:ip] + "   " + node[:hostname] + "' >> /etc/hosts" + "\n"
    end  #NODES


    NODES.each do |node|
        config.vm.define node[:hostname] do |cfg|
            cfg.vm.box = node[:box]
            cfg.vm.hostname = node[:hostname]
            cfg.vm.network "private_network", ip: node[:ip]
            cfg.vm.provider "virtualbox" do |v|
                v.customize ["modifyvm", :id, "--natdnshostresolver1", "on"]
                v.customize ["modifyvm", :id, "--memory", node[:mem] ]
                v.customize ["modifyvm", :id, "--name", node[:hostname] ]
                v.customize ["modifyvm", :id, "--cpus", node[:cpu] ]
            end #provider
        
            # exec pour tous 
            cfg.vm.provision :shell, :inline => etcHosts
            cfg.vm.provision :shell,  :path => "common.sh"

            # exec selon type 
            # DNS 
            if node[:type] == "dns"
                cfg.vm.provision :shell, :path => "install_dns.sh", :args => domainName
            end #dns

            if node[:type] == "pki"
                cfg.vm.provision :shell, :path => "install_stepCA.sh", :args => domainName
            end #pki
        
            if node[:type] == "web"
                cfg.vm.provision :shell, :path => "install_web.sh", :args => domainName
            end #pki
        end #config
    end #nodes
end
